#include <stdio.h>
#include <stdlib.h>


#define NR 50
#define NC 50

#define TRUE 1
#define FALSE 0


void  scambio_righe(float [][NC],int , int , int , int );
void  flip(float *, float *);
void  gauss3(float [][NC], int , int , int , int );
void  somma_righe(float [][NC], int , int , int , int );
void  stampa_matrice(float [][NC],int , int );
void  leggi_matrice(float [][NC],int , int );
int   triangolarizza(float [][NC],int , int );
float calcola_determinante(float [][NC],int , int );
int scegli_un_intero(int , int );


int main ()
{
  int ok,n_righe,n_colonne,riga1,riga2,scelta;
  int nscambi;
  float mat1[NR][NC];

   //acquisizione della prima dimensione
   printf("Quante righe vuoi utilizzare?  ");
   n_righe=scegli_un_intero(1,NR);

   //acquisizione della seconda dimensione
   printf("Quante colonne vuoi utilizzare?  ");
   n_colonne=scegli_un_intero(1,NC);

   printf("Dammi la matrice\n");
   leggi_matrice(mat1,n_righe,n_colonne);


   ok=TRUE;
   while(ok){
     system("cls\n");
     printf("MENU\n\n");
     printf("1)  Scambiare righe\n");
     printf("2)  Sommare righe\n");
     printf("3)  Terza mossa di Gauss\n");
     printf("4)  Triangolarizzazione\n");
     printf("5)  Determinante\n");
     printf("6)  stampare la  matrice\n");
     printf("7)  uscire dal programma\n");

     scanf("%d",&scelta);

     switch(scelta){
       case 1:
            system("cls\n");

            printf("Dammi la prima riga da scambiare:\n");
			riga1=scegli_un_intero(0,n_righe-1);
            printf("Dammi la seconda riga da scambiare:\n");
			riga2=scegli_un_intero(0,n_righe-1);

			scambio_righe(mat1,riga1,riga2,0,n_colonne);

            printf("Matrice con riga scambiata:\n");
			stampa_matrice(mat1,n_righe,n_colonne);

			getchar();
			getchar();
			break;
       case 2:
            system("cls\n");


            printf("Dammi la riga da sostituire durante la somma:\n");
			riga1=scegli_un_intero(0,n_righe-1);
            printf("Dammi la  riga da sommare:\n");
			riga2=scegli_un_intero(0,n_righe-1);

			somma_righe(mat1,riga1,riga2,0,n_colonne);

            printf("Matrice con riga sommata:\n");
			stampa_matrice(mat1,n_righe,n_colonne);

			getchar();
			getchar();
			break;
       case 3:
            system("cls\n");


            printf("Dammi la riga da sostituire durane la somma (terza mossa di Gauss):\n");
			riga1=scegli_un_intero(0,n_righe-1);
            printf("Dammi la riga da sommare (terza mossa di Gauss):\n");
			riga2=scegli_un_intero(0,n_righe-1);

			gauss3(mat1,riga1,riga2,0,n_colonne);

            printf("Matrice con riga sommata (terza mossa di Gauss):\n");
			stampa_matrice(mat1,n_righe,n_colonne);

			getchar();
			getchar();
			break;
       case 4:
            system("cls\n");

			nscambi=triangolarizza(mat1,n_righe,n_colonne);
            printf("Matrice triangolare (numero scambi= %d):\n",nscambi);
			stampa_matrice(mat1,n_righe,n_colonne);

			getchar();
			getchar();
			break;
       case 5:
            system("cls\n");

			if(n_righe==n_colonne){
			   printf("Determinante: %f\n",calcola_determinante(mat1,n_righe,n_colonne));
		    }else
			  printf("Calcolo non possibile: la matrice non e quadrata\n");


			getchar();
			getchar();
			break;
       case 6:
            system("cls\n");
            printf("Matrice:\n");
			stampa_matrice(mat1,n_righe,n_colonne);
			getchar();
			getchar();
			break;
       case 7:
            system("cls\n");
			ok=FALSE;
			break;
	   default:
            system("cls\n");
            printf("Caso non attivo\n");
			getchar();
			getchar();
     }//switch
   }//while


}

int scegli_un_intero(int minimo, int massimo)
//ritorna un intero scelto dall'utente fra minimo e massimo (compresi)
{
	int scelta;

	do{
       printf("Intero (compreso fra %d e %d):  ",minimo, massimo);
       scanf("%d",&scelta);
	}while(scelta<minimo||scelta>massimo);


	return scelta;
}

float  calcola_determinante(float a[][NC],int n_righe, int n_colonne)
// calcola il determinante di una matrice quadrata
{
  int i,nscambi;
  float determinante=1;


  nscambi=triangolarizza(a,n_righe,n_colonne);
  for(i=0;i<n_righe;i++)
	  determinante*=a[i][i];

  for(i=0;i<nscambi;i++)
    determinante*=-1;

  return determinante;
}

int  triangolarizza(float a[][NC],int n_righe, int n_colonne)
// mette la matrice in forma triangolare
{
	int i,k,trovato;
	int nscambi=0,colonna_attuale;


	colonna_attuale=0;
    for(i=0;i<n_righe-1;i++){
	  //se la riga base ha elemento nullo nella colonna base, scambiala con la prima riga successiva con elemento diverso da zero
	  trovato=FALSE;
	  if(a[i][colonna_attuale]==0){
         for(k=i+1;(k<n_righe)&&trovato==FALSE;k++)
	       if(a[k][colonna_attuale]!=0){
			 scambio_righe(a,i,k,0,n_colonne);
			 trovato=TRUE;
			 nscambi++;
	       }
	  }

	  //se la riga base ha elemento non nullo nella colonna base, effettua la terza mossa sulle righe successive
	  if(a[i][colonna_attuale]!=0){
        for(k=i+1;k<n_righe;k++)
		  if(a[k][colonna_attuale]!=0) //se il coefficiente della riga k  nullo, non devo fare nulla
	        gauss3(a,k,i,colonna_attuale,n_colonne);
	  }else
	    i--; //devo insistere sulla riga

	  //sposto la colonna in esame
	  colonna_attuale++;
	  if(colonna_attuale==n_colonne) //se arrivo in fondo ho finito
		  break;

	}//for i

	return nscambi;
}




void  leggi_matrice(float a[][NC],int nrighe, int ncolonne)
// legge una matrice
{

  int i,j;

    for(i=0;i<nrighe;i++){
	  printf("Riga numero %d: ",i);
      for(j=0;j<ncolonne;j++)
		  scanf("%f",&a[i][j]);
	}

}


void  stampa_matrice(float a[][NC],int nrighe, int ncolonne)
// stampa una matrice
{

  int i,j;

    for(i=0;i<nrighe;i++){
      for(j=0;j<ncolonne;j++)
		  printf("%f\t",a[i][j]);
	  printf("\n");
	}

}



void  scambio_righe(float a[][NC],int riga1, int riga2, int inizio_colonna, int fine_colonna)
// la funzione scambia tra di loro le righe "riga1" e "riga2"
// agisce fra le colonne "inizio_colonna" e "fine_colonna"
{

  int j;
  float ftmp;

    for(j=inizio_colonna;j<fine_colonna;j++)
	   flip(&(a[riga1][j]),&(a[riga2][j]));

}

void flip(float *a, float *b)
// la funzione scambia fra di loro i valori di due float
{

  float ftmp;

  ftmp=*a;
  *a=*b;
  *b=ftmp;

}


void somma_righe(float a[][NC], int riga, int base, int inizio_colonna, int fine_colonna)
// somma la seconda riga sulla prima
// agisce fra le colonne "inizio_colonna" e "fine_colonna"
{

   int j;

    for(j=inizio_colonna;j<fine_colonna;j++)
       a[riga][j]+=a[base][j];

}


void gauss3(float a[][NC], int riga, int base, int inizio_colonna, int fine_colonna)
// effettua la terza mossa di Gauss
// R_riga<--R_riga-(primo_coefficiente_riga)/primo_coefficiente_base)*R_base
// agisce fra le colonne "inizio_colonna" e "fine_colonna"
{

   int j;
   float coefficiente;

   /*
   printf("riga base= \t");
   for(j=0;j<fine_colonna;j++)
	   printf("%f\t",a[base][j]);
   printf("\n");

   printf("riga riga= \t");
   for(j=0;j<fine_colonna;j++)
	   printf("%f\t",a[riga][j]);
   printf("\n");

   printf("num= %f\tden= %f\n",a[riga][inizio_colonna],a[base][inizio_colonna]);
   getchar();
   getchar();
   */
   coefficiente=-a[riga][inizio_colonna]/a[base][inizio_colonna];

   for(j=inizio_colonna;j<fine_colonna;j++)
       a[riga][j]+=a[base][j]*coefficiente;

}




/*#include <stdio.h>
#include <stdlib.h>
#include <math.h>

# define  DIM  1000

# define  NR  100
# define  NC  100

void leggi_vettore(float [],int );
void stampa_vettore(float [],int );

float prodotto_scalare(float [],float [],int );
float modulo(float [],int );
float angolo_fra_vettori(float [],float [],int );

void leggi_matrice(float [][NC],int , int );
void stampa_matrice(float [][NC],int , int );



int main ()
{
   int i,scelta,ok,n_righe,n_colonne,n_elementi=0;
   int primo,secondo;
   float  vett1[DIM],vett2[DIM],prodotto;
   float matrice[NR][NC];



   printf("Dimmi quante righe:  ");
   scanf("%d",&n_righe);

   printf("Dimmi quante colonne:  ");
   scanf("%d",&n_colonne);

   printf("Dammi la matrice:  ");
   leggi_matrice(matrice,n_righe,n_colonne);




   ok=1;
   while(ok){
	 system("cls\n");
     printf("MENU\n");
     printf("1) stampa matrice\n");
     printf("2) prodotto scalare\n");
     printf("3) modulo\n");
     printf("4) angolo\n");
     printf("6) esci\n");
     scanf("%d",&scelta);

	 switch(scelta){
		 case 1:
	            system("cls\n");
                printf("Matrice:\n");
				stampa_matrice(matrice,n_righe,n_colonne);
				getchar();
				getchar();
			    break;
		 case 2:
	            system("cls\n");

				printf("dammi il primo vettore: ");
				scanf("%d",&primo);

				printf("dammi il secondo vettore: ");
				scanf("%d",&secondo);

                prodotto=prodotto_scalare(matrice[primo],matrice[secondo],n_colonne);

				printf("Il prodotto scalare e: %f\n",prodotto);

				getchar();
				getchar();
			    break;
		 case 3:
	            system("cls\n");

				printf("dammi il  vettore: ");
				scanf("%d",&primo);

                printf("Il modulo del  vettore e:  %f\n",modulo(matrice[primo],n_colonne));

				getchar();
				getchar();
			    break;
		 case 4:
	            system("cls\n");

				printf("dammi il primo vettore: ");
				scanf("%d",&primo);

				printf("dammi il secondo vettore: ");
				scanf("%d",&secondo);

                printf("L'angolo e:  %f\n",angolo_fra_vettori(matrice[primo],matrice[secondo],n_colonne));

				getchar();
				getchar();
			    break;
		 case 6:
			    ok=0;
			    break;
	 }
	 system("cls\n");
   }
   printf("Fine delle operazioni\n");
}


float angolo_fra_vettori(float v1[],float v2[],int n)
{ int i;
  float mod1, mod2,angolo;


  mod1=modulo(v1, n);
  if(mod1==0)
	  return 0;

  mod2=modulo(v2, n);
  if(mod2==0)
	  return 0;

  //calcolo dell'angolo
  angolo=acos(prodotto_scalare(v1,v2,n)/(mod1*mod2));

  //angolo in gradi
  angolo=angolo*180.0/3.14159;

  return angolo;
}


float modulo(float v[],int n)
{

   return sqrt(prodotto_scalare(v,v,n));

}


float prodotto_scalare(float v1[],float v2[],int n)
{ int i;
  float risposta=0;

  for(i=0;i<n;i++)
	  risposta+=v1[i]*v2[i];

  return risposta;
}



void leggi_matrice(float mat[][NC],int n, int m)
{

  int i,j;

  for(i=0;i<n;i++){
	printf("Dammi la riga %d:",i);
    for(j=0;j<m;j++)
	    scanf("%f",&mat[i][j]);
  }
}

void stampa_matrice(float mat[][NC],int n, int m)
{

  int i,j;

  for(i=0;i<n;i++){
    for(j=0;j<m;j++)
	    printf("%f\t",mat[i][j]);
	printf("\n");
  }
}



void leggi_vettore(float v[],int n)
{ int i;

  for(i=0;i<n;i++)
	  scanf("%f",&v[i]);
}

void stampa_vettore(float v[],int n)
{ int i;

  for(i=0;i<n;i++)
	  printf("%f\t",v[i]);
  printf("\n");
}

*/

/*

#include <stdio.h>
#include <stdlib.h>
#include <math.h>

#define NR 50
#define NC 50


void stampa_matrice(float [][NC], int , int );
void leggi_matrice(float [][NC], int , int );
void stampa_vettore(float [], int);
float prod_scalare_vettori(float [], float [], int);
float modulo(float [], int );
int angolo_vettori(float *, float [], float [], int );


int main ()
{

   int i,scelta,ok,n_righe,n_colonne,vett1,vett2;
   float mat[NR][NC],angolo;


   //acquisizione del numero di righe
   printf("Quante righe vuoi immettere?  ");
   scanf("%d",&n_righe);

   //acquisizione del numero di colonne
   printf("Quante righe vuoi immettere?  ");
   scanf("%d",&n_colonne);

   leggi_matrice(mat,n_righe,n_colonne);


   ok=1;
   while(ok){
	 system("cls\n");
     printf("MENU\n");
     printf("1) Stampa di un vettore riga a scelta\n");
     printf("2) Stampa dei vettori riga\n");
     printf("3) Stampa del prodotto scalare di due vettori riga\n");
     printf("4) Stampa del modulo di un vettore a scelta\n");
     printf("5) Stampa dell'angolo fra due vettori a scelta\n");
     printf("6) esci\n");
     scanf("%d",&scelta);

	 switch(scelta){
		 case 1:
	            system("cls\n");

				do{
					printf("Dammi un vettore:  ");
					scanf("%d",&vett1);
				}while(vett1<0||vett1>=n_righe);

				stampa_vettore(mat[vett1],n_righe);

				getchar();
				getchar();
			    break;
		 case 2:
	            system("cls\n");

				for(i=0;i<n_righe;i++)
				  stampa_vettore(mat[i],n_righe);

				getchar();
				getchar();
			    break;
		 case 3:
	            system("cls\n");

				do{
					printf("Dammi il primo vettore:  ");
					scanf("%d",&vett1);
				}while(vett1<0||vett1>=n_righe);

				do{
					printf("Dammi il secondo vettore:  ");
					scanf("%d",&vett2);
				}while(vett2<0||vett2>=n_righe);

                printf("Il prodotto scalare  e: %f\n",prod_scalare_vettori(mat[vett1],mat[vett2],n_righe));

				getchar();
				getchar();
			    break;
		 case 4:
	            system("cls\n");


				do{
					printf("Dammi un vettore:  ");
					scanf("%d",&vett1);
				}while(vett1<0||vett1>=n_righe);

                printf("Il modulo del  vettore e: %f\n",modulo(mat[vett1],n_righe));

				getchar();
				getchar();
			    break;
		 case 5:
	            system("cls\n");

				do{
					printf("Dammi il primo vettore:  ");
					scanf("%d",&vett1);
				}while(vett1<0||vett1>=n_righe);

				do{
					printf("Dammi il secondo vettore:  ");
					scanf("%d",&vett2);
				}while(vett2<0||vett2>=n_righe);

                if(angolo_vettori(&angolo,mat[vett1],mat[vett2],n_righe))
					printf("L'angolo e: %f\n",angolo);
				else
					printf("Calcolo non possibile (uno dei due vettori ha modulo nullo)\n");

				getchar();
				getchar();
			    break;
		 case 6:
			    ok=0;
			    break;
	 }
	 system("cls\n");
   }

   printf("Fine delle operazioni\n");

}



int angolo_vettori(float *angolo, float vett1[], float vett2[], int n)
// calcola l'angolo fra due vettori
{
   int i;
   float mod1,mod2;

   mod1=modulo(vett1,n);
   if(mod1==0)
	   return 0;

   mod2=modulo(vett2,n);
   if(mod2==0)
	   return 0;

   //calcolo dell'angolo in radianti
   *angolo=acos(prod_scalare_vettori(vett1,vett2,n)/(mod1*mod2));

   //calcolo dell'angolo in gradi
   *angolo=(*angolo)*180.0/3.14159265;

   return 1;
}


float modulo(float vett1[], int n)
// modulo di vett1
{
   float prod=0;

   return sqrt(prod_scalare_vettori(vett1,vett1,n));
}


float prod_scalare_vettori(float vett1[], float vett2[], int n)
// prodotto scalare fra vett1 e vett2
{
   int i;
   float prod=0;

   for(i=0;i<n;i++)
      prod+=vett1[i]*vett2[i];

  return prod;
}


void stampa_vettore(float mat[], int n)
// stampa un vettore
{

   int i;

   for(i=0;i<n;i++)
       printf("%f\t",mat[i]);
     printf("\n");
}


void stampa_matrice(float mat[][NC], int n, int m)
// stampa la matrice
{

   int i,j;

   for(i=0;i<n;i++){
     for(j=0;j<m;j++)
       printf("%f\t",mat[i][j]);
     printf("\n");
   }
}



void leggi_matrice(float mat[][NC], int n, int m)
// legge la matrice
{

   int i,j;

   for(i=0;i<n;i++){
     printf("Dammi la riga n. %d :  ",i);
     for(j=0;j<m;j++)
       scanf("%f",&mat[i][j]);
   }
}


*/


/*

#include <stdio.h>

void scambia_interi(int *, int *);
float calcola_media(float [], int );


int main ()
{

  int a,b,itmp,n;
  float v1={12.4,56.7.34.5};

  printf("dammi due interi\n");
  scanf("%d%d",&a,&b);

  printf("a:  %d\n",a);
  printf("b:  %d\n",b);

  printf("\n");


  n=3;


  v1[2]=34.56



  //itmp=a;
  //a=b;
  //b=itmp;


  scambia_interi(&a,&b);


  printf("a:  %d\n",a);
  printf("b:  %d\n",b);

  mediavettore=calcola_media(v1,n);

}


void dividi(float vett[], int n)
{
	int i;

  for(i=0;i<n;i++)
	  vett[i]/=n;

}



void scambia_interi(int *a, int *b)
{
  int itmp;

  itmp=*a;
  *a=*b;
  *b=itmp;

}

*/





/*
#include <stdio.h>
#include <stdlib.h>


#define NR 50
#define NC 50

#define TRUE 1
#define FALSE 0


void  scambio_righe(float [][NC],int , int , int , int );
void  flip(float *, float *);
void  sostituisci_riga(float [][NC], int , int , int , int );
void  somma_righe(float [][NC], int , int , int , int );
void  stampa_matrice(float [][NC],int , int );
void  leggi_matrice(float [][NC],int , int );
int   triangolarizza(float [][NC],int , int );
float calcola_determinante(float [][NC],int , int );


int main ()
{
  int ok,n_righe,n_colonne,riga1,riga2,scelta;
  int nscambi;
  float mat1[NR][NC];

   //acquisizione della prima dimensione
   printf("Quante righe vuoi utilizzare?  ");
   scanf("%d",&n_righe);

   //acquisizione della seconda dimensione
   printf("Quante colonne vuoi utilizzare?  ");
   scanf("%d",&n_colonne);

   printf("Dammi la matrice\n");
   leggi_matrice(mat1,n_righe,n_colonne);


   ok=TRUE;
   while(ok){
     system("cls\n");
     printf("MENU\n\n");
     printf("1)  Scambiare righe\n");
     printf("2)  Sommare righe\n");
     printf("3)  Terza mossa di Gauss\n");
     printf("4)  Triangolarizzazione\n");
     printf("5)  Determinante\n");
     printf("6)  stampare la  matrice\n");
     printf("7)  uscire dal programma\n");

     scanf("%d",&scelta);

     switch(scelta){
       case 1:
            system("cls\n");

            printf("Dimmi le righe che vuoi scambiare:\n");
			do{
                printf("Prima riga (fra 0 e %d):  ",n_righe-1);
                scanf("%d",&riga1);
			}while(riga1<0||riga1>=NR);

			do{
                printf("Seconda riga (fra 0 e %d):  ",n_righe-1);
                scanf("%d",&riga2);
			}while(riga2<0||riga2>=NR);

			scambio_righe(mat1,riga1,riga2,0,n_colonne);

            printf("Matrice con riga scambiata:\n");
			stampa_matrice(mat1,n_righe,n_colonne);

			getchar();
			getchar();
			break;
       case 2:
            system("cls\n");

            printf("Dimmi le righe che vuoi sommare:\n");
			do{
                printf("Riga da sostituire durane la somma (fra 0 e %d):  ",n_righe-1);
                scanf("%d",&riga1);
			}while(riga1<0||riga1>=NR);

			do{
                printf("Riga da sommare (fra 0 e %d):  ",n_righe-1);
                scanf("%d",&riga2);
			}while(riga2<0||riga2>=NR);

			somma_righe(mat1,riga1,riga2,0,n_colonne);

            printf("Matrice con riga sommata:\n");
			stampa_matrice(mat1,n_righe,n_colonne);

			getchar();
			getchar();
			break;
       case 3:
            system("cls\n");

            printf("Dimmi le righe che vuoi sommare (terza mossa di Gauss):\n");
			do{
                printf("Riga da sostituire durane la somma (fra 0 e %d):  ",n_righe-1);
                scanf("%d",&riga1);
			}while(riga1<0||riga1>=NR);

			do{
                printf("Riga da sommare (fra 0 e %d):  ",n_righe-1);
                scanf("%d",&riga2);
			}while(riga2<0||riga2>=NR);

			sostituisci_riga(mat1,riga1,riga2,0,n_colonne);

            printf("Matrice con riga sommata (terza mossa di Gauss):\n");
			stampa_matrice(mat1,n_righe,n_colonne);

			getchar();
			getchar();
			break;
       case 4:
            system("cls\n");

			nscambi=triangolarizza(mat1,n_righe,n_colonne);
            printf("Matrice triangolare (numero scambi= %d):\n",nscambi);
			stampa_matrice(mat1,n_righe,n_colonne);

			getchar();
			getchar();
			break;
       case 5:
            system("cls\n");

			if(n_righe==n_colonne){
			   printf("Determinante: %f\n",calcola_determinante(mat1,n_righe,n_colonne));
		    }else
			  printf("Calcolo non possibile: la matrice non e quadrata\n");


			getchar();
			getchar();
			break;
       case 6:
            system("cls\n");
            printf("Matrice:\n");
			stampa_matrice(mat1,n_righe,n_colonne);
			getchar();
			getchar();
			break;
       case 7:
            system("cls\n");
			ok=FALSE;
			break;
	   default:
            system("cls\n");
            printf("Caso non attivo\n");
			getchar();
			getchar();
     }//switch
   }//while


}

*/
/*
float  calcola_determinante(float a[][NC],int n_righe, int n_colonne)
// calcola il determinante di una matrice quadrata
{
  int i,nscambi;
  float determinante=1;


  nscambi=triangolarizza(a,n_righe,n_colonne);
  for(i=0;i<n_righe;i++)
	  determinante*=a[i][i];

  for(i=0;i<nscambi;i++)
    determinante*=-1;

  return determinante;
}

int  triangolarizza(float a[][NC],int n_righe, int n_colonne)
// mette la matrice in forma triangolare
{
	int i,k,trovato;
	int nscambi=0,colonna_attuale;


	colonna_attuale=0;
    for(i=0;i<n_righe-1;i++){
	  //printf("Pietra angolare [%d][%d]: %f\n",i,colonna_attuale,mat1[i][colonna_attuale]);
	  //se la riga base ha elemento nullo nella colonna base, scambiala con la prima riga successiva con elemento diverso da zero
	  trovato=FALSE;
	  if(a[i][colonna_attuale]==0){
         for(k=i+1;(k<n_righe)&&trovato==FALSE;k++)
	       if(a[k][colonna_attuale]!=0){
			 scambio_righe(a,i,k,0,n_colonne);
			 trovato=TRUE;
			 nscambi++;
	       }
	  }else
	    if(a[i][colonna_attuale]!=0) //faccio le terze mosse, se posso
          for(k=i+1;k<n_righe;k++)
	        sostituisci_riga(a,k,i,colonna_attuale,n_colonne);

	  if(a[i][colonna_attuale]==0)
			i--; //devo insistere sulla riga

	  //sposto la colonna
	  colonna_attuale++;

	  //}//for j
	}//for i

	return nscambi;
}




void  leggi_matrice(float a[][NC],int nrighe, int ncolonne)
// legge una matrice
{

  int i,j;

    for(i=0;i<nrighe;i++){
	  printf("Riga numero %d: ",i);
      for(j=0;j<ncolonne;j++)
		  scanf("%f",&a[i][j]);
	}

}


void  stampa_matrice(float a[][NC],int nrighe, int ncolonne)
// stampa una matrice
{

  int i,j;

    for(i=0;i<nrighe;i++){
      for(j=0;j<ncolonne;j++)
		  printf("%f\t",a[i][j]);
	  printf("\n");
	}

}



void  scambio_righe(float a[][NC],int riga1, int riga2, int inizio_colonna, int fine_colonna)
// la funzione scambia tra di loro le righe "riga1" e "riga2"
// agisce fra le colonne "inizio_colonna" e "fine_colonna"
{

  int j;
  float ftmp;

    for(j=inizio_colonna;j<fine_colonna;j++)
	   flip(&(a[riga1][j]),&(a[riga2][j]));

}

void flip(float *a, float *b)
// la funzione scambia fra di loro i valori di due float
{

  float ftmp;

  ftmp=*a;
  *a=*b;
  *b=ftmp;

}


void somma_righe(float a[][NC], int riga, int base, int inizio_colonna, int fine_colonna)
// somma la seconda riga, sulla prima
// agisce fra le colonne "inizio_colonna" e "fine_colonna"
{

   int j;

    for(j=inizio_colonna;j<fine_colonna;j++)
       a[riga][j]+=a[base][j];

}


void sostituisci_riga(float a[][NC], int riga, int base, int inizio_colonna, int fine_colonna)
// effettua la terza mossa di Gauss
// R_riga<--R_riga-(primo_coefficiente_riga)/primo_coefficiente_base)*R_base
// agisce fra le colonne "inizio_colonna" e "fine_colonna"
{

   int j;
   float coefficiente;

   /*
   printf("riga base= \t");
   for(j=0;j<fine_colonna;j++)
	   printf("%f\t",a[base][j]);
   printf("\n");

   printf("riga riga= \t");
   for(j=0;j<fine_colonna;j++)
	   printf("%f\t",a[riga][j]);
   printf("\n");

   printf("num= %f\tden= %f\n",a[riga][inizio_colonna],a[base][inizio_colonna]);
   getchar();
   getchar();
   ****
   coefficiente=-a[riga][inizio_colonna]/a[base][inizio_colonna];

   for(j=inizio_colonna;j<fine_colonna;j++)
       a[riga][j]+=a[base][j]*coefficiente;

}


/*
void sostituisci_riga(float a[][NC], int riga, int base, int inizio_colonna, int fine_colonna)
// effettua la terza mossa di Gauss
// R_riga<--R_riga-(primo_coefficiente_riga)/primo_coefficiente_base)*R_base
// agisce fra le colonne "inizio_colonna" e "fine_colonna"
{

   int j;

     for(j=fine_colonna-1;j>=inizio_colonna;j--)
       a[riga][j]+=-a[base][j]*(a[riga][inizio_colonna]/a[base][inizio_colonna]);

}
*/



/*

#include <stdio.h>

int massimo(int,int);
int radice(int);
float media_vettore(int [],int );

int main ()
{

  int i,vett[100],n_valori;

  printf("Dammi numero numeri: ");
  scanf("%d",&n_valori);


  for(i=0;i<n_valori;i++){
    printf("numero %d:  ",i);
	scanf("%d",&vett[i]);
  }


  for(i=0;i<n_valori;i++)
    vett[i]=radice(vett[i]);


  printf("I risultati sono:\n");
  for(i=0;i<n_valori;i++)
    printf("%d\n",vett[i]);

  printf("la media e':  %f\n",media_vettore(vett,n_valori));


}


float media_vettore(int vettr[],int n_valori)
{
	int i;
	float media;

	media=0;
	for(i=0;i<n_valori;i++)
      media+=vettr[i];

  return media/n_valori;
}



int radice(int n) {
	int x;

	for(x=0; x*x <= n; x++)
		;

	return x-1;
}


int massimo(int x,int y)
{

  if(x>y)
	  return x;
  else
	  return y;
}


*/

/*
#include <stdio.h>
#include <stdlib.h>


#define NR 50
#define NC 50

#define TRUE 1
#define FALSE 0
{
int main ()
{
  int ok,i,j,k,n_righe,n_colonne,scelta;
  int mat1[NR][NC],mat2[NR][NC],mat3[NR][NC];

   //acquisizione della prima dimensione
   printf("Quante righe vuoi utilizzare?  ");
   scanf("%d",&n_righe);

   //acquisizione della seconda dimensione
   printf("Quante colonne vuoi utilizzare?  ");
   scanf("%d",&n_colonne);

   printf("Dammi la prima matrice\n");
   for(i=0;i<n_righe;i++){
     printf("Riga numero %d: ",i);
     for(j=0;j<n_colonne;j++)
       scanf("%d",&mat1[i][j]);
   }

   printf("Dammi la seconda matrice\n");
   for(i=0;i<n_righe;i++){
     printf("Riga numero %d: ",i);
     for(j=0;j<n_colonne;j++)
       scanf("%d",&mat2[i][j]);
   }



   ok=TRUE;
   while(ok){
     system("cls\n");
     printf("MENU\n\n");
     printf("1)  stampare la matrice somma\n");
     printf("2)  stampare la matrice prodotto\n");
     printf("3)  stampare le due matrici iniziali\n");
     printf("4)  uscire dal programma\n");

     scanf("%d",&scelta);

     switch(scelta){
       case 1:
            system("cls\n");

            printf("Matrice somma:\n");
            for(i=0;i<n_righe;i++){
              for(j=0;j<n_colonne;j++)
                printf("%d\t",mat1[i][j]+mat2[i][j]);
              printf("\n");
            }


			getchar();
			getchar();
			break;
       case 2:
            system("cls\n");

            printf("Matrice prodotto:\n");

			if(n_righe==n_colonne){
            for(i=0;i<n_righe;i++)
              for(j=0;j<n_colonne;j++){
				  mat3[i][j]=0;
                  for(k=0;k<n_righe;k++)
					  mat3[i][j]=mat3[i][j]+mat1[i][k]*mat2[k][j];
		      }

			for(i=0;i<n_righe;i++){
              for(j=0;j<n_colonne;j++)
				  printf("%d\t",mat3[i][j]);
			  printf("\n");

			}



			}else
			   printf("Prodotto non possibile");

			getchar();
			getchar();
			break;
       case 3:
            system("cls\n");


            printf("Prima matrice:\n");
            for(i=0;i<n_righe;i++){
              for(j=0;j<n_colonne;j++)
                printf("%d\t",mat1[i][j]);
              printf("\n");
            }

            printf("Seconda matrice:\n");
            for(i=0;i<n_righe;i++){
              for(j=0;j<n_colonne;j++)
                printf("%d\t",mat2[i][j]);
              printf("\n");
            }

			getchar();
			getchar();
			break;
       case 4:
            system("cls\n");
			ok=FALSE;
			break;
	   default:
            system("cls\n");
            printf("Caso non attivo\n");
			getchar();
			getchar();
     }//switch
   }//while


}


*/
/*
#include <stdio.h>
#include <stdlib.h>


#define NR 50
#define NC 50

#define TRUE 1
#define FALSE 0


int main ()
{
  int ok,i,j,k,n_righe,n_colonne,scelta;
  int mata[NR][NC],matb[NR][NC],matc[NR][NC];

   //acquisizione delel dimensioni
   printf("Quanti righe vuoi immettere?  ");
   scanf("%d",&n_righe);
   printf("Quanti colonne vuoi immettere?  ");
   scanf("%d",&n_colonne);

   for(i=0;i<n_righe;i++){
     printf("Matrice A - dammi la riga [%d]:\n",i);
     for(j=0;j<n_colonne;j++)
       scanf("%d",&mata[i][j]);
   }


   for(i=0;i<n_righe;i++){
     printf("Matrice B - dammi la riga [%d]:\n",i);
     for(j=0;j<n_colonne;j++)
       scanf("%d",&matb[i][j]);
   }


   ok=TRUE;
   while(ok){
     system("cls\n");
     printf("MENU\n\n");
     printf("1)  matrice somma\n");
     printf("2)  matrice prodotto\n");
     printf("3)  stampa matrici\n");
     printf("4)  esci\n");

     scanf("%d",&scelta);

     switch(scelta){
       case 1:
            system("cls\n");
			printf("Matrice somma:\n");
            for(i=0;i<n_righe;i++){
              for(j=0;j<n_colonne;j++)
                printf("%d\t",mata[i][j]+matb[i][j]);
              printf("\n");
            }
			getchar();
			getchar();
			break;
       case 2:
            system("cls\n");
			if(n_colonne!=n_righe)
				printf("Il calcolo non e possibile\n");
			else{
              for(i=0;i<n_righe;i++)
                 for(j=0;j<n_colonne;j++){
				   matc[i][j]=0;
                     for(k=0;k<n_colonne;k++)
						matc[i][j]+=mata[i][k]*matb[k][j];
				 }//for

			  printf("Matrice prodotto:\n");
              for(i=0;i<n_righe;i++){
                for(j=0;j<n_colonne;j++)
                  printf("%d\t",matc[i][j]);
                printf("\n");
              }
			}//else
			getchar();
			getchar();
			break;
       case 3:
            system("cls\n");
			printf("Matrice A:\n");
            for(i=0;i<n_righe;i++){
              for(j=0;j<n_colonne;j++)
                printf("%d\t",mata[i][j]);
              printf("\n");
            }

			printf("Matrice B:\n");
            for(i=0;i<n_righe;i++){
              for(j=0;j<n_colonne;j++)
                printf("%d\t",matb[i][j]);
              printf("\n");
            }

			getchar();
			getchar();
			break;
       case 4:
            system("cls\n");
            printf("4)  OK\n");
			ok=FALSE;
			break;
	   default:
            system("cls\n");
            printf("Caso non attivo\n");
			getchar();
			getchar();
     }//switch
   }//while


}

*/

/*

#include <stdio.h>
#include <stdlib.h>


#define N 1000
#define TRUE 1
#define FALSE 0

int main ()
{
  int ok,i,j,n_elementi,scelta,valore,trovato;
  int vett1[N];

   //acquisizione del vettore
   printf("Quanti valori vuoi immettere?  ");
   scanf("%d",&n_elementi);

   for(i=0;i<n_elementi;i++){
     printf("Dammi l'elemento n. %d:  ",i);
     scanf("%d",&vett1[i]);
   }



   ok=TRUE;
   while(ok){
     system("cls\n");
     printf("MENU\n\n");
     printf("1)  aggiungi un elemento al vettore\n");
     printf("2)  cerca un elemento nel vettore\n");
     printf("3)  elimina un elemento dal vettore\n");
     printf("4)  mostra il vettore attuale\n");
     printf("5)  esci\n");

     scanf("%d",&scelta);

     switch(scelta){
       case 1:
            system("cls\n");
			printf("Dammi il nuovo elemento:");
			scanf("%d",&vett1[n_elementi]);
            n_elementi++;
			getchar();
			getchar();
			break;
       case 2:
            system("cls\n");

			printf("Dammi il numero da cercare:");
			scanf("%d",&valore);

			trovato=FALSE;
            for(i=0;(i<n_elementi)&&(!trovato);i++)
				if(valore==vett1[i])
					trovato=TRUE;

			if(trovato)
				printf("Il valore e presente\n");
			else
				printf("Il valore non e presente\n");


			getchar();
			getchar();
			break;
       case 3:
            system("cls\n");

			printf("Dammi il numero da eliminare:");
			scanf("%d",&valore);

            for(i=0,trovato=0;i<n_elementi;i++)
				if(vett1[i]==valore){
                  for(j=i;j<n_elementi-1;j++)
			        vett1[j]=vett1[j+1];
				  n_elementi--;
				  i--;
				  trovato++;
				}
		    printf("Sono stati eliminati %d elementi\n",trovato);
			getchar();
			getchar();
			break;
       case 4:
            system("cls\n");
            for(i=0;i<n_elementi;i++)
             printf("vett[%d]: %d\n",i,vett1[i]);
			getchar();
			getchar();
			break;
       case 5:
            system("cls\n");
            printf("5)  OK\n");
			ok=FALSE;
			break;
	   default:
            system("cls\n");
            printf("Caso non attivo\n");
			getchar();
			getchar();
     }//switch
   }//while


}



*/

/*

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

       case 3:
            system("cls\n");

			printf("Dammi il numero da eliminare:");
			scanf("%d",&valore);

            for(i=0,trovato=0;i<n_elementi;i++)
				if(vett1[i]==valore){
			        vett1[i]=vett1[n_elementi-1];
					n_elementi--;
					i--;
					trovato++;
				}
		    printf("Sono stati eliminati %d elementi\n",trovato);
			getchar();
			getchar();
			break;


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%









#include <stdio.h>

#define N 1000

int main ()
{
  int i,j,n_elementi;
  int vett1[N],vett2[N];

   //acquisizione del vettore
   printf("Quanti valori vuoi immettere?  ");
   scanf("%d",&n_elementi);

   for(i=0;i<n_elementi;i++){
     printf("Dammi l'elemento n. %d:  ",i);
     scanf("%d",&vett1[i]);
   }


   for(i=0,j=0;i<n_elementi;i++)
	   if(vett1[i]>9 && vett1[i] <501){
		   vett2[j]=vett1[i];
		   j++;
		}


   for(i=0;i<j;i++)
     printf("vett2[%d]: %d\n",i,vett2[i]);



}

*/

/*
#include <stdio.h>
#include <stdlib.h>

int main ()
{

   int i,scelta,ok,n_elementi,trovato;
   float vett[50],da_cercare;


   //acquisizione del vettore
   printf("Quanti valori vuoi immettere?  ");
   scanf("%d",&n_elementi);

   for(i=0;i<n_elementi;i++){
     printf("Dammi l'elemento n. %d:  ",i);
     scanf("%f",&vett[i]);
   }


   ok=1;
   while(ok){
	 system("cls\n");
     printf("MENU\n");

     printf("1) aggiungi un elemento al vettore\n");
     printf("2) cerca un valore nel vettore\n");
     printf("3) elimina un valore nel vettore\n");
     printf("4) mostra vettore attuale\n");
     printf("5) esci\n");
     scanf("%d",&scelta);

	 switch(scelta){
		 case 1:
	            system("cls\n");
                printf("Inserisci valore da aggiungere\n");
                scanf("%f",&vett[n_elementi]);
				n_elementi++;
			    break;
		 case 2:
	            system("cls\n");
                printf("Inserisci valore da cercare\n");
                scanf("%f",&da_cercare);
				trovato=1;
			    for(i=0;i<n_elementi;i++)
					if(vett[i]==da_cercare){
						printf("Valore %f trovato in posizione %d\n",da_cercare,i);
						trovato=0;
				    }
				if(trovato)
					printf("Il valore %f non e' presente nel vettore\n",da_cercare);
				getchar();
				getchar();
			    break;
		 case 3:
	            system("cls\n");
                printf("Inserisci valore da eliminare\n");
                scanf("%f",&da_cercare);
				trovato=1;
				i=0;
			    while(i<n_elementi)
					if(vett[i]==da_cercare){
						vett[i]=vett[n_elementi-1];
						n_elementi--;
						trovato=0;
				    }else
					    i++;
				if(trovato)
					printf("Il valore %f non e' presente nel vettore\n",da_cercare);
				else
					printf("Il valore %f  e' stato eliminato\n",da_cercare);
				getchar();
				getchar();
			    break;
		 case 4:
	            system("cls\n");
			    for(i=0;i<n_elementi;i++)
					printf("%f\t",vett[i]);
				getchar();
				getchar();
			    break;
		 case 5:
			    ok=0;
			    break;
	 }
	 system("cls\n");
   }

   printf("Fine delle operazioni\n");

}

*/
/*

#include <stdio.h>

#define N 500

int main()
{
  int i,j,massimo,posizione,dim;
  int vett1[N],vett2[N];


  do{
     printf("Quanti numeri devo utilizzare?  ");
     scanf("%d", &dim);
  }while( (dim<0)||dim>=N );



  printf("Dammi %d numeri interi\n",dim);
  for (i=0; i<dim; i++)
      scanf("%d", &vett1[i]);


  for (i=0,j=0; i<dim; i++){
      printf("vett1[%d]: %d\n", i, vett1[i]);
	  if(50<vett1[i]&&500>vett1[i]){
		  vett2[j]=vett1[i];
	      j++;
	  }
  }

  for (i=0; i<j; i++)
      printf("vett2[%d]: %d\n", i, vett2[i]);

}

*/

/*
#include <stdio.h>

#define N 500
#define TRUE 1
#define FALSE 0

int main()
{
  int i,dim,trovato;
  float media;
  float vett [N];



  printf("Dammi le temperature\n");

  trovato=TRUE;
  for (i=0; (i<N)&&(trovato); i++){
	    printf("Dammi la temperatura %d:  ",i);
        scanf("%f", &vett[i]);
		if(vett[i]<0)
			trovato=FALSE;
  }

  dim=i-1;

  media=vett[0];
  printf("vett[%d]: %f\n", 0, vett[0]);

  for (i=1; i<dim; i++){
      printf("vett[%d]: %f\n", i, vett[i]);
	  media=media+vett[i];
  }

  printf("La media e: %f\n",media/dim);


}
*/

/*

#include <stdio.h>

#define N 500

int main()
{
  int i,dim;
  float media;
  float vett [N];


  do{
     printf("Quante temerature devo utilizzare?  ");
     scanf("%d", &dim);
  }while( (dim<0)||dim>=N );


  printf("Dammi %d temperature\n",dim);
  for (i=0; i<dim; i++){
	  do{
	    printf("Dammi la tempeatura %d:  ",i);
        scanf("%f", &vett[i]);
	  }while(vett[i]<0);
  }


  media=vett[0];
  printf("vett[%d]: %f\n", 0, vett[0]);

  for (i=1; i<dim; i++){
      printf("vett[%d]: %f\n", i, vett[i]);
	  media=media+vett[i];
  }

  printf("La media e: %f\n",media/dim);


}

*/
/*
#include <stdio.h>

#define N 500

int main()
{
  int i,massimo,posizione,dim;
  int vett [N];


  do{
     printf("Quanti numeri devo utilizzare?  ");
     scanf("%d", &dim);
  }while( (dim<0)||dim>=N );



  printf("Dammi %d numeri interi\n",dim);
  for (i=0; i<dim; i++){
	  //printf("Dammi il numero %d:  ",i);
      scanf("%d", &vett[i]);
  }


  massimo=vett[0];
  posizione=0;
  printf("vett[%d]: %d\n", 0, vett[0]);


  for (i=1; i<dim; i++){
      printf("vett[%d]: %d\n", i, vett[i]);
	  if(massimo<vett[i]){
		  massimo=vett[i];
	      posizione=i;
	  }
  }

  printf("Il massimo e: %d, e in posizione %d\n",massimo,posizione+1);



}


*/
