#include <stdio.h>
#include <stdlib.h>


#define NR 50
#define NC 50

#define TRUE 1
#define FALSE 0


void  scambio_righe(float [][NC],int , int , int , int );
void  flip(float *, float *);
void  gauss3(float [][NC], int , int , int , int );
void  somma_righe(float [][NC], int , int , int , int );
void  stampa_matrice(float [][NC],int , int );
void  leggi_matrice(float [][NC],int , int );
int   triangolarizza(float [][NC],int , int );
float calcola_determinante(float [][NC],int , int );
int scegli_un_intero(int , int );


int main ()
// calcolo del determinante con funzioni
// il men permette la verifica indipendente di alcune delle funzioni utilizzate
{
  int ok,n_righe,n_colonne,riga1,riga2,scelta;
  int nscambi;
  float mat1[NR][NC];

   //acquisizione della prima dimensione
   printf("Quante righe vuoi utilizzare?  ");
   n_righe=scegli_un_intero(1,NR);

   //acquisizione della seconda dimensione
   printf("Quante colonne vuoi utilizzare?  ");
   n_colonne=scegli_un_intero(1,NC);

   printf("Dammi la matrice\n");
   leggi_matrice(mat1,n_righe,n_colonne);


   ok=TRUE;
   while(ok){
     system("cls\n");
     printf("MENU\n\n");
     printf("1)  Scambiare righe\n");
     printf("2)  Sommare righe\n");
     printf("3)  Terza mossa di Gauss\n");
     printf("4)  Triangolarizzazione\n");
     printf("5)  Determinante\n");
     printf("6)  stampare la  matrice\n");
     printf("7)  uscire dal programma\n");

     scanf("%d",&scelta);

     switch(scelta){
       case 1:
            system("cls\n");

            printf("Dammi la prima riga da scambiare:\n");
			riga1=scegli_un_intero(0,n_righe-1);
            printf("Dammi la seconda riga da scambiare:\n");
			riga2=scegli_un_intero(0,n_righe-1);

			scambio_righe(mat1,riga1,riga2,0,n_colonne);

            printf("Matrice con riga scambiata:\n");
			stampa_matrice(mat1,n_righe,n_colonne);

			getchar();
			getchar();
			break;
       case 2:
            system("cls\n");


            printf("Dammi la riga da sostituire durante la somma:\n");
			riga1=scegli_un_intero(0,n_righe-1);
            printf("Dammi la  riga da sommare:\n");
			riga2=scegli_un_intero(0,n_righe-1);

			somma_righe(mat1,riga1,riga2,0,n_colonne);

            printf("Matrice con riga sommata:\n");
			stampa_matrice(mat1,n_righe,n_colonne);

			getchar();
			getchar();
			break;
       case 3:
            system("cls\n");


            printf("Dammi la riga da sostituire durane la somma (terza mossa di Gauss):\n");
			riga1=scegli_un_intero(0,n_righe-1);
            printf("Dammi la riga da sommare (terza mossa di Gauss):\n");
			riga2=scegli_un_intero(0,n_righe-1);

			gauss3(mat1,riga1,riga2,0,n_colonne);

            printf("Matrice con riga sommata (terza mossa di Gauss):\n");
			stampa_matrice(mat1,n_righe,n_colonne);

			getchar();
			getchar();
			break;
       case 4:
            system("cls\n");

			nscambi=triangolarizza(mat1,n_righe,n_colonne);
            printf("Matrice triangolare (numero scambi= %d):\n",nscambi);
			stampa_matrice(mat1,n_righe,n_colonne);

			getchar();
			getchar();
			break;
       case 5:
            system("cls\n");

			if(n_righe==n_colonne){
			   printf("Determinante: %f\n",calcola_determinante(mat1,n_righe,n_colonne));
		    }else
			  printf("Calcolo non possibile: la matrice non e quadrata\n");


			getchar();
			getchar();
			break;
       case 6:
            system("cls\n");
            printf("Matrice:\n");
			stampa_matrice(mat1,n_righe,n_colonne);
			getchar();
			getchar();
			break;
       case 7:
            system("cls\n");
			ok=FALSE;
			break;
	   default:
            system("cls\n");
            printf("Caso non attivo\n");
			getchar();
			getchar();
     }//switch
   }//while


}

int scegli_un_intero(int minimo, int massimo)
//ritorna un intero scelto dall'utente fra minimo e massimo (compresi)
{
	int scelta;

	do{
       printf("Intero (compreso fra %d e %d):  ",minimo, massimo);
       scanf("%d",&scelta);
	}while(scelta<minimo||scelta>massimo);


	return scelta;
}

float  calcola_determinante(float a[][NC],int n_righe, int n_colonne)
// calcola il determinante di una matrice quadrata
{
  int i,nscambi;
  float determinante=1;


  nscambi=triangolarizza(a,n_righe,n_colonne);
  for(i=0;i<n_righe;i++)
	  determinante*=a[i][i];

  for(i=0;i<nscambi;i++)
    determinante*=-1;

  return determinante;
}

int  triangolarizza(float a[][NC],int n_righe, int n_colonne)
// mette la matrice in forma triangolare
{
	int i,k,trovato;
	int nscambi=0,colonna_attuale;


	colonna_attuale=0;
    for(i=0;i<n_righe-1;i++){
	  //se la riga base ha elemento nullo nella colonna base, scambiala con la prima riga successiva con elemento diverso da zero
	  trovato=FALSE;
	  if(a[i][colonna_attuale]==0){
         for(k=i+1;(k<n_righe)&&trovato==FALSE;k++)
	       if(a[k][colonna_attuale]!=0){
			 scambio_righe(a,i,k,0,n_colonne);
			 trovato=TRUE;
			 nscambi++;
	       }
	  }

	  //se la riga base ha elemento non nullo nella colonna base, effettua la terza mossa sulle righe successive
	  if(a[i][colonna_attuale]!=0){
        for(k=i+1;k<n_righe;k++)
		  if(a[k][colonna_attuale]!=0) //se il coefficiente della riga k  nullo, non devo fare nulla
	        gauss3(a,k,i,colonna_attuale,n_colonne);
	  }else
	    i--; //devo insistere sulla riga

	  //sposto la colonna in esame
	  colonna_attuale++;
	  if(colonna_attuale==n_colonne) //se arrivo in fondo ho finito
		  break;

	}//for i

	return nscambi;
}




void  leggi_matrice(float a[][NC],int nrighe, int ncolonne)
// legge una matrice
{

  int i,j;

    for(i=0;i<nrighe;i++){
	  printf("Riga numero %d: ",i);
      for(j=0;j<ncolonne;j++)
		  scanf("%f",&a[i][j]);
	}

}


void  stampa_matrice(float a[][NC],int nrighe, int ncolonne)
// stampa una matrice
{

  int i,j;

    for(i=0;i<nrighe;i++){
      for(j=0;j<ncolonne;j++)
		  printf("%f\t",a[i][j]);
	  printf("\n");
	}

}



void  scambio_righe(float a[][NC],int riga1, int riga2, int inizio_colonna, int fine_colonna)
// la funzione scambia tra di loro le righe "riga1" e "riga2"
// agisce fra le colonne "inizio_colonna" e "fine_colonna"
{

  int j;
  float ftmp;

    for(j=inizio_colonna;j<fine_colonna;j++)
	   flip(&(a[riga1][j]),&(a[riga2][j]));

}

void flip(float *a, float *b)
// la funzione scambia fra di loro i valori di due float
{

  float ftmp;

  ftmp=*a;
  *a=*b;
  *b=ftmp;

}


void somma_righe(float a[][NC], int riga, int base, int inizio_colonna, int fine_colonna)
// somma la seconda riga sulla prima
// agisce fra le colonne "inizio_colonna" e "fine_colonna"
{

   int j;

    for(j=inizio_colonna;j<fine_colonna;j++)
       a[riga][j]+=a[base][j];

}


void gauss3(float a[][NC], int riga, int base, int inizio_colonna, int fine_colonna)
// effettua la terza mossa di Gauss
// R_riga<--R_riga-(primo_coefficiente_riga)/primo_coefficiente_base)*R_base
// agisce fra le colonne "inizio_colonna" e "fine_colonna"
{

   int j;
   float coefficiente;

   /*
   printf("riga base= \t");
   for(j=0;j<fine_colonna;j++)
	   printf("%f\t",a[base][j]);
   printf("\n");

   printf("riga riga= \t");
   for(j=0;j<fine_colonna;j++)
	   printf("%f\t",a[riga][j]);
   printf("\n");

   printf("num= %f\tden= %f\n",a[riga][inizio_colonna],a[base][inizio_colonna]);
   getchar();
   getchar();
   */
   coefficiente=-a[riga][inizio_colonna]/a[base][inizio_colonna];

   for(j=inizio_colonna;j<fine_colonna;j++)
       a[riga][j]+=a[base][j]*coefficiente;

}


